// GaugeDoc.cpp : implementation of the CGaugeDoc class
//

#include "stdafx.h"
#include "Gauge.h"

#include "GaugeDoc.h"
#include "PasteSettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGaugeDoc

IMPLEMENT_DYNCREATE(CGaugeDoc, CDocument)

BEGIN_MESSAGE_MAP(CGaugeDoc, CDocument)
	//{{AFX_MSG_MAP(CGaugeDoc)
	ON_COMMAND(ID_ZERO, OnZero)
	ON_COMMAND(ID_PASTE, OnPaste)
	ON_COMMAND(ID_OPTIONS_COMPORT, OnOptionsComport)
	ON_COMMAND(ID_OPTIONS_PASTE, OnOptionsPaste)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGaugeDoc construction/destruction

CGaugeDoc::CGaugeDoc()
{
	// TODO: add one-time construction code here
	m_iIn=m_iMM=m_iIn2=m_iMM2=0x80000000;
	m_iAbs=m_iZero=0x80000000;
	m_iComState=0;
	m_hwndPaste=NULL;
}

CGaugeDoc::~CGaugeDoc()
{
	EscapeCommFunction(m_hComm,CLRDTR);
	EscapeCommFunction(m_hComm,CLRRTS);
	CloseHandle(m_hComm);
}

BOOL CGaugeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	OpenPort();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGaugeDoc serialization

void CGaugeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGaugeDoc diagnostics

#ifdef _DEBUG
void CGaugeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGaugeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGaugeDoc commands

void CGaugeDoc::OpenPort(void)
{
	m_sComPort="COM1";
	CString s;
	s="\\\\.\\"+m_sComPort;
	m_hComm=CreateFile(s,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
	if(m_hComm==INVALID_HANDLE_VALUE) {
		TRACE("Error opening comm port\n");
		m_hComm=NULL;
		DWORD dwErr=GetLastError();
		if(dwErr==2) {
			m_sComPortError.Format("Unable to open port %s - Port not found (Error 2)",m_sComPort);
		} else if(dwErr==5) {
			m_sComPortError.Format("Unable to open port %s - Port is already in use (Error 5)",m_sComPort);
		} else {
			m_sComPortError.Format("Unable to open port %s - Error %u",m_sComPort,dwErr);
		}
		m_bShowComPortError=TRUE;
	} else {
		///g_reg.Write("COM Port",m_sComPort);
		m_sComPortError.Format("Opened port %s - Handle = %i",m_sComPort,m_hComm);
		m_bShowComPortError=TRUE;
		DCB dcb;
		dcb.DCBlength=sizeof(dcb);
		GetCommState(m_hComm,&dcb);
		dcb.BaudRate=9600;		// baud rate 
		dcb.fBinary=1;			// binary mode, no EOF check
		dcb.fParity=0;			// no parity checking 
		dcb.fOutxCtsFlow=0;		// CTS output flow control 
		dcb.fOutxDsrFlow=0;		// DSR output flow control 
		dcb.fDtrControl=0;		// DTR flow control type 
		dcb.fDsrSensitivity=0;	// DSR sensitivity 
		dcb.fTXContinueOnXoff=0;// XOFF continues Tx 
		dcb.fOutX=0;			// XON/XOFF out flow control 
		dcb.fInX=0;				// XON/XOFF in flow control 
		dcb.fErrorChar=0;		// error replacement enable/disable
		dcb.fNull=0;			// null stripping enable/disable
		dcb.fRtsControl=0;		// RTS flow control 
		dcb.fAbortOnError=0;	// abort reads/writes on error 
		//DWORD fDummy2:17;		// reserved 
		//WORD wReserved;		// not currently used 
		//WORD XonLim;			// transmit XON threshold 
		//WORD XoffLim;			// transmit XOFF threshold 
		dcb.ByteSize=8;			// number of bits/byte, 4-8 
		dcb.Parity=NOPARITY;	// 0-4=no,odd,even,mark,space 
		dcb.StopBits=0;			// 0,1,2 = 1, 1.5, 2 
		//char XonChar;			// Tx and Rx XON character 
		//char XoffChar;		// Tx and Rx XOFF character 
		dcb.ErrorChar=0x00;		// error replacement character
		//char EofChar;			// end of input character 
		//char EvtChar;			// received event character 
		//WORD wReserved1;		// reserved; do not use 
		SetCommState(m_hComm,&dcb);


		TRACE0("--- DCB Dump ---\r\n");
		TRACE1("Baud Rate: %i\r\n",dcb.BaudRate);
		TRACE2("Binary: %s  Parity: %s\r\n",dcb.fBinary?"Yes":"No",dcb.fParity?"On":"Off");
		TRACE2("CTS flow control: %s  DSR flow control: %s\r\n",dcb.fOutxCtsFlow?"On":"Off",dcb.fOutxDsrFlow?"On":"Off");
		TRACE0("DTR Control: ");
		switch(dcb.fDtrControl) {
			case DTR_CONTROL_DISABLE: TRACE0("Disable\r\n");	break;
			case DTR_CONTROL_ENABLE: TRACE0("Enable\r\n"); break;
			case DTR_CONTROL_HANDSHAKE:	TRACE0("Handshake\r\n"); break;
			default: TRACE0("\r\n");	break;
		}
		TRACE1("DSR Senstivity: %s\r\n",dcb.fDsrSensitivity?"On":"Off");
		TRACE1("TX Continue on X-Off: %s\r\n",dcb.fTXContinueOnXoff?"Yes":"No");
		TRACE2("X-On/X-Off flow control  Out: %s  In: %s\r\n",dcb.fOutX?"On":"Off",dcb.fInX?"On":"Off");
		TRACE1("Error replacement: %s\r\n",dcb.fErrorChar?"On":"Off");
		TRACE1("Strip Nulls: %s\r\n",dcb.fNull?"Yes":"No");
		TRACE0("RTS Control: ");
		switch(dcb.fRtsControl) {
			case RTS_CONTROL_DISABLE: TRACE0("Disable\r\n"); break;
			case RTS_CONTROL_ENABLE: TRACE0("Enable\r\n"); break;
			case RTS_CONTROL_HANDSHAKE: TRACE0("Handshake\r\n"); break;
			case RTS_CONTROL_TOGGLE: TRACE0("Toggle\r\n"); break;
		}
		TRACE1("Abort on Error: %s\r\n",dcb.fAbortOnError?"Yes":"No");
		//DWORD fDummy2:17;		// reserved 
		//WORD wReserved;		// not currently used 
		TRACE1("X-On threshold: %i\r\n",dcb.XonLim);
		TRACE1("X-Off threshold: %i\r\n",dcb.XoffLim);
		TRACE1("Byte size: %i\r\n",dcb.ByteSize);
		TRACE0("Parity: ");
		switch(dcb.Parity) {
			case 0: TRACE0("None\r\n"); break;
			case 1: TRACE0("Odd\r\n"); break;
			case 2: TRACE0("Even\r\n"); break;
			case 3: TRACE0("Mark\r\n"); break;
			case 4: TRACE0("Space\r\n"); break;
			default: TRACE0("???\r\n");
		}
		TRACE0("Stop Bits: ");
		switch(dcb.StopBits) {
			case 0: TRACE0("1\r\n"); break;
			case 1: TRACE0("1.5\r\n"); break;
			case 2: TRACE0("2\r\n"); break;
			default: TRACE0("?\r\n"); break;
		}
		TRACE2("X-On char: 0x%02X  X-Off char: 0x%02X\r\n",dcb.XonChar,dcb.XoffChar);
		TRACE2("Error char: 0x%02X  EOF char: 0x%02X\r\n",dcb.ErrorChar,dcb.EofChar);
		TRACE1("Event char: 0x%02X\r\n",dcb.EvtChar);
		//WORD wReserved1;		// reserved; do not use 
		TRACE0("\r\n");
		
		
		COMMTIMEOUTS to;
		GetCommTimeouts(m_hComm,&to);
		to.ReadIntervalTimeout=MAXDWORD;
		to.ReadTotalTimeoutMultiplier=0;
		to.ReadTotalTimeoutConstant=0;
		//to.WriteTotalTimeoutMultiplier; 
		//to.WriteTotalTimeoutConstant; 
		SetCommTimeouts(m_hComm,&to);

		TRACE0("--- COMTIMEOUTS Dump ---\r\n");
		TRACE1("Read Interval Timeout: %i\r\n",to.ReadIntervalTimeout);
		TRACE1("Read Total Timeout Multiplier: %i\r\n",to.ReadTotalTimeoutMultiplier);
		TRACE1("Read Total Timeout Constant: %i\r\n",to.ReadTotalTimeoutConstant);
		TRACE1("Write Total Timeout Multiplier: %i\r\n",to.WriteTotalTimeoutMultiplier);
		TRACE1("Write Total Timeout Constant: %i\r\n",to.WriteTotalTimeoutConstant);
		TRACE0("\r\n");

		EscapeCommFunction(m_hComm,SETDTR);
		EscapeCommFunction(m_hComm,SETRTS);
	}
}

void CGaugeDoc::ReadCom(void)
{
	if(m_iComState==0) {
		EscapeCommFunction(m_hComm,SETBREAK);
		Sleep(50);
		EscapeCommFunction(m_hComm,CLRBREAK);
		Sleep(50);
		PurgeComm(m_hComm,PURGE_RXCLEAR);
		DWORD dw;

		WriteFile(m_hComm,"V",1,&dw,NULL);
		Sleep(150);
		COMSTAT cs;
		ClearCommError(m_hComm,&dw,&cs);
		TRACE1("InQue: %i\n",cs.cbInQue);
		if(cs.cbInQue>1) {
			CString sVersion;
			ReadFile(m_hComm,sVersion.GetBuffer(cs.cbInQue),cs.cbInQue-1,&dw,NULL);
			sVersion.ReleaseBuffer(dw);
			TRACE1("Version: %s\n",(LPCSTR)sVersion);
		}
		PurgeComm(m_hComm,PURGE_RXCLEAR);

		WriteFile(m_hComm,"C",1,&dw,NULL);
		Sleep(200);
		ClearCommError(m_hComm,&dw,&cs);
		TRACE1("InQue: %i\n",cs.cbInQue);
		if(cs.cbInQue>1) {
			CString sCopyright;
			ReadFile(m_hComm,sCopyright.GetBuffer(cs.cbInQue),cs.cbInQue-1,&dw,NULL);
			sCopyright.ReleaseBuffer(dw);
			TRACE1("Copyright: %s\n",(LPCSTR)sCopyright);
		}
		PurgeComm(m_hComm,PURGE_RXCLEAR);

		WriteFile(m_hComm,"B",1,&dw,NULL);
		Sleep(50);
		PurgeComm(m_hComm,PURGE_RXCLEAR);

		WriteFile(m_hComm,"E",1,&dw,NULL);
		++m_iComState;
		return;
	}

	BYTE by[16];
	DWORD dwRead;
	ReadFile(m_hComm,&by,8,&dwRead,NULL);
	//TRACE1("Serial Bytes: %i\n",dwRead);
	if(dwRead > 0 && dwRead < 8) {
		Sleep(100);
		DWORD dw;
		ReadFile(m_hComm,&by+dwRead,8-dwRead,&dw,NULL);
		dwRead+=dw;
		//TRACE1("Extra %i\n",dw);
	}
	PurgeComm(m_hComm,PURGE_RXCLEAR);
	if(dwRead==8) {
		int i=by[1]<<16|by[2]<<8|by[3];
		if(i & 0x00800000) i|=0xFF000000;
		if(FormatInches(i,m_iIn,m_sIN))
			UpdateAllViews(NULL,1);
		if(FormatMM(i,m_iMM,m_sMM))
			UpdateAllViews(NULL,2);
		m_iAbs=by[4]<<16|by[5]<<8|by[6];
		if(m_iAbs & 0x00800000) m_iAbs|=0xFF000000;
		if(m_iZero==0x80000000) m_iZero=m_iAbs;
		if(FormatInches(m_iZero-m_iAbs,m_iIn2,m_sIN2))
			UpdateAllViews(NULL,3);
		if(FormatMM(m_iZero-m_iAbs,m_iMM2,m_sMM2))
			UpdateAllViews(NULL,4);
		TRACE("%i  %02X %02X %02X  %02X %02X %02X  %s  %s\n",dwRead,
			by[1],by[2],by[3],by[4],by[5],by[6],m_sIN,m_sMM);
#if 0
		__int64 lIn=i;
		lIn=(lIn*0x7D00)>>16;
		__int64 lMM=i;
		lMM=(lMM*0x1FC0)>>16;
		TRACE2("%i %i  %i %i\n",lIn,lMM);
#endif
#if 0
		int p,m,iBits;
		p=0;
		m=0x7F;		// MM
		iBits=10;	// MM
		//m=0x7D;		// Inches
		//iBits=8;	// Inches
		ASSERT(iBits>0);
		do {
			if(m & 1) p+=i;
			m>>=1;
			p>>=1;
		} while(--iBits);
		TRACE1("%i\n",p);
#endif
	} else if(dwRead) {
		TRACE("%i\n",dwRead);
	}
}

void CGaugeDoc::OnZero() 
{
	m_iZero=m_iAbs;	
}

BOOL CGaugeDoc::FormatInches(int i, int& iLast, CString &s)
{
	const BOOL bNeg=i<0;
	if(bNeg) i=~i;
	i=i*125/256;	// ==*32000/65536, 125/256
	i-=i%5;			// Last digit must be 0 or 5
	if((bNeg?~i:i)!=iLast) {
		iLast=(bNeg?~i:i);
		const float f=i/10000.0f;
		s.Format("%c%.4f",bNeg?'-':' ',f);
#if 0
		int l=s.GetLength()-1;
		char c=s[l];
		s.SetAt(l,c<'5'?'0':'5');
#endif
		return TRUE;
	} else
		return FALSE;
}

BOOL CGaugeDoc::FormatMM(int i, int& iLast, CString& s)
{
	const BOOL bNeg=i<0;
	if(bNeg) i=~i;
	i=i*127/1024;	// ==*8128/65536, 508/4096, 127/1024
	if((bNeg?~i:i)!=iLast) {
		iLast=(bNeg?~i:i);
		const float f=i/100.0f;
		s.Format("%c%.2f",bNeg?'-':' ',f);
		return TRUE;
	} else
		return FALSE;
}

void CGaugeDoc::OnPaste()
{
	if(m_hwndPaste==NULL) return;
	CWnd* pWnd=CWnd::FromHandle(m_hwndPaste);
	const BOOL bAlt=GetKeyState(VK_MENU)&(1<<15);
	if(bAlt) keybd_event(VK_MENU,MapVirtualKey(VK_MENU,0),KEYEVENTF_KEYUP,0);
	CWnd* wndFore=CWnd::GetForegroundWindow();
	const DWORD dwSourceThreadId=GetCurrentThreadId();
	const DWORD dwTargetThreadId=GetWindowThreadProcessId(pWnd->GetSafeHwnd(),0);
	AttachThreadInput(dwSourceThreadId,dwTargetThreadId,TRUE);
	pWnd->SetFocus();
	CString s=m_sIN;
	s+='\r';
	for(int i=0;i<s.GetLength();i++) {
		char c=s[i];
		switch(c) {
			case '.':
				c=VK_DECIMAL;
				break;
			case '\n':
				c=VK_RETURN;
				break;
			case '\t':
				c=VK_TAB;
				break;
			case ' ':
				continue;
		}
		const UINT scancode=MapVirtualKey(c,0);
		keybd_event(c,scancode,0,0);
		keybd_event(c,scancode,KEYEVENTF_KEYUP,0);
	}
	AttachThreadInput(dwSourceThreadId,dwTargetThreadId,FALSE);
	Sleep(1000);
	//Sleep(100);
	const DWORD dwPid=GetWindowThreadProcessId(GetForegroundWindow(),NULL);
	if(dwPid!=dwSourceThreadId)
		AttachThreadInput(dwPid,dwSourceThreadId,TRUE);
	wndFore->SetForegroundWindow();
	if(dwPid!=dwSourceThreadId)
		AttachThreadInput(dwPid,dwSourceThreadId,FALSE);
	if(bAlt) keybd_event(VK_MENU,MapVirtualKey(VK_MENU,0),0,0);
}

void CGaugeDoc::OnOptionsComport() 
{
	// TODO: Add your command handler code here
	
}

void CGaugeDoc::OnOptionsPaste() 
{
	CPasteSettingsDlg dlg;

	if(dlg.DoModal()==IDOK) {
		m_hwndPaste=dlg.m_hwnd;
		TRACE1("HWND: %08X\n",dlg.m_hwnd);
	}
}
