// GaugeView.h : interface of the CGaugeView class
//
/////////////////////////////////////////////////////////////////////////////

class CGaugeView : public CView
{
protected: // create from serialization only
	void SizeToFont(void);
	CGaugeView();
	DECLARE_DYNCREATE(CGaugeView)

// Attributes
public:
	CGaugeDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGaugeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGaugeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CFont m_font;
	int m_iCellWidth;
	int m_iCellHeight;
	enum {
		eInches,
		eMM,
		eBoth
	} m_eViewUnits;
	enum {
		eGauge,
		eLocal,
		eBothZeros
	} m_eViewZeros;

// Generated message map functions
protected:
	//{{AFX_MSG(CGaugeView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnViewFont();
	afx_msg void OnViewInches();
	afx_msg void OnViewMm();
	afx_msg void OnViewBoth();
	afx_msg void OnViewGaugezero();
	afx_msg void OnViewLocalzero();
	afx_msg void OnViewBothzero();
	afx_msg void OnUpdateViewInches(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewMm(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewBoth(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewGaugezero(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewLocalzero(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewBothzero(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GaugeView.cpp
inline CGaugeDoc* CGaugeView::GetDocument()
   { return (CGaugeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
